#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <dos.h>

#define SIZEOFXFER 3

unsigned Segm, Off;
unsigned DSegm, DOff;
unsigned long * FP;
signed long I;

unsigned long GetClockHz(void);

int ending = 0;
const signed long NumSamples = 100000;
unsigned long datavalue=0L;
unsigned long Den, Naui;
unsigned long Base, Base2;
unsigned long buf[SIZEOFXFER+1];
unsigned long ClockHz = GetClockHz();

unsigned long InPortL(unsigned Port);
void OutPortL(unsigned Port, unsigned long Value);

typedef char* PChar;
const PChar VM = (PChar)MK_FP(0xB800, 0);

typedef struct
{
  unsigned short VID;
  unsigned long DID;
  unsigned long Base[4];
  unsigned char IRQ;
} TCard;

typedef union
{
  struct
  {
    unsigned char Addr;
    unsigned char Function: 3;
    unsigned char Device: 5;
    unsigned char Bus;
    unsigned char Header;
  } P;
  unsigned long Trans;
} TCardTrans;

TCard DetectedCard[20];
unsigned DetectedCards = 0;

void Put12Spaces(void)
{
  cputs("            ");
}

void PutWordPadded(unsigned short Data)
{
  char HexChar[16] = "0123456789ABCDEF";

  putch(HexChar[(Data >> 12) & 0xF]);
  putch(HexChar[(Data >>  8) & 0xF]);
  putch(HexChar[(Data >>  4) & 0xF]);
  putch(HexChar[(Data      ) & 0xF]);
  cputs("        ");
}

void PutDWordPadded(unsigned long Data)
{
  char HexChar[16] = "0123456789ABCDEF";

  putch(HexChar[(Data >> 28) & 0xF]);
  putch(HexChar[(Data >> 24) & 0xF]);
  putch(HexChar[(Data >> 20) & 0xF]);
  putch(HexChar[(Data >> 16) & 0xF]);
  putch(HexChar[(Data >> 12) & 0xF]);
  putch(HexChar[(Data >>  8) & 0xF]);
  putch(HexChar[(Data >>  4) & 0xF]);
  putch(HexChar[(Data      ) & 0xF]);
  cputs("    ");
}

void PutWord(unsigned short Data)
{
  char HexChar[16] = "0123456789ABCDEF";

  if ( Data & 0xF000 ) putch(HexChar[(Data >> 12) & 0xF]);
  if ( Data & 0xFF00 ) putch(HexChar[(Data >>  8) & 0xF]);
  if ( Data & 0xFFF0 ) putch(HexChar[(Data >>  4) & 0xF]);
                       putch(HexChar[(Data      ) & 0xF]);
}

void PutBAR(unsigned long Data)
{
  if ( Data )
  {
    if ( Data & 1 )
      PutWordPadded(Data & 0xFFFE);
    else
      PutDWordPadded(Data)
    ;
  }
  else
    Put12Spaces()
  ;
}

void SetLineColor(unsigned dLine, unsigned char Color)
{
  PChar mSel = VM + 160 * dLine + 1;
  for ( int I = 0; I < 11 * 6; ++I )
    mSel[I * 2] = Color
  ;
}

void SetCellColor(unsigned dLine, unsigned Col, unsigned char Color)
{
  PChar mSel = VM + 160 * dLine + 16 * Col + 1;
  for ( int I = 0; I < 8; ++I )
    mSel[I * 2] = Color
  ;
}

unsigned long ValBase(unsigned long Base)
{
  if ( Base & 1 )
    return Base & 0xFFFFFFFE;
  else
    return Base & 0xFFFFFFF0
  ;
}

signed short AskForCard(void)
{
  textattr(0x07);

  {
    for ( int I = 0; I < sizeof(DetectedCard); ++I )
    {
      //*(PChar(DetectedCard) + I) = 0xDC;
      (PChar(DetectedCard))[I] = 0xDC;
    }
  }

  {
    int Bus, Device;
    TCardTrans Trans;

    cputs("Loading card data...\r\n");

    Trans.P.Header = 0x80;
    Trans.P.Addr = 0;
    Trans.P.Function = 0;
    for ( Bus = 0; Bus < 256; ++Bus )
    {
      Trans.P.Bus = Bus;
      for ( Device = 0; Device < 32; ++Device )
      {
        Trans.P.Device = Device;
        OutPortL(0xCF8, Trans.Trans);
        DetectedCard[DetectedCards].VID = inport(0xCFC);
        if ( DetectedCard[DetectedCards].VID == 0xFFFF )
        {
          //if ( Device == 0 ) break;
          continue;
        }
        //cprintf("%04X\r\n", DetectedCard[DetectedCards].VID);
        if ( DetectedCard[DetectedCards].VID != 0x494F ) continue;

        DetectedCard[DetectedCards].DID = inport(0xCFE);
        //Retrieve base addresses 2-5, which become 0-3
        OutPortL(0xCF8, Trans.Trans | 0x18);
        DetectedCard[DetectedCards].Base[0] = InPortL(0xCFC);
        OutPortL(0xCF8, Trans.Trans | 0x1C);
        DetectedCard[DetectedCards].Base[1] = InPortL(0xCFC);
        OutPortL(0xCF8, Trans.Trans | 0x20);
        DetectedCard[DetectedCards].Base[2] = InPortL(0xCFC);
        OutPortL(0xCF8, Trans.Trans | 0x24);
        DetectedCard[DetectedCards].Base[3] = InPortL(0xCFC);
        OutPortL(0xCF8, Trans.Trans | 0x3C);
        DetectedCard[DetectedCards].IRQ = inportb(0xCFC);
        ++DetectedCards;
        if ( DetectedCards == 20 ) goto Dun;
      }
    }
    Dun: ;
  }

  clrscr();

  {
    if ( DetectedCards == 0 )
    {
      cputs("No cards were found! Exiting.\r\n\r\n");
      exit(1);
    }

    cputs("Select a card from this list, or hit Escape to exit.\r\n\r\n");
    cputs("PCI ID      Base[2]     Base[3]     Base[4]     Base[5]     IRQ\r\n");

    for ( int I = 0; I < DetectedCards; ++I )
    {
      PutDWordPadded((unsigned long)(DetectedCard[I].VID) << 16 | DetectedCard[I].DID);
      PutBAR(DetectedCard[I].Base[0]);
      PutBAR(DetectedCard[I].Base[1]);
      PutBAR(DetectedCard[I].Base[2]);
      PutBAR(DetectedCard[I].Base[3]);
      if ( DetectedCard[I].IRQ != 0xFF )
        PutWord(DetectedCard[I].IRQ)
      ;
      cputs("\r\n");
    }
  }

  int CurSel = 0;//, XSel = 1;
  while(-1)
  {
    //SetCellColor(2 + CurSel, XSel, 0x1F);
    SetLineColor(3 + CurSel, 0x1F);
    char Key = getch();
    //SetCellColor(2 + CurSel, XSel, 0x07);
    SetLineColor(3 + CurSel, 0x07);
    switch(Key)
    {
      case 0:
        switch(getch())
        {
          case 'H':
            if ( CurSel > 0 ) --CurSel;
          break;

          case 'P':
            if ( CurSel < DetectedCards - 1 ) ++CurSel;
          break;

          //case 'K':
          //  if ( XSel > 1 ) --XSel;
          //break;
          //
          //case 'M':
          //  if ( XSel < 4 ) ++XSel;
          //break;

          case 'G':
            CurSel = 0;
          break;

          case 'O':
            CurSel = DetectedCards - 1;
          break;
        }
      break;

      case 32: case 13:
        return CurSel;
        //if ( (XSel == 1) && DetectedCard[CurSel].Base0 ) return DetectedCard[CurSel].Base0;
        //if ( (XSel == 2) && DetectedCard[CurSel].Base1 ) return DetectedCard[CurSel].Base1;
        //if ( (XSel == 3) && DetectedCard[CurSel].Base2 ) return DetectedCard[CurSel].Base2;
        //if ( (XSel == 4) && DetectedCard[CurSel].Base3 ) return DetectedCard[CurSel].Base3;
        //sound(1000);
        //delay(100);
        //nosound();
      //break;

      case 27:
        //exit(0);
        return -1;
      //break;
    }
  }
}

#pragma inline
unsigned long InPortL(unsigned Port)
{
  asm {
    mov dx,[Port]
    in eax,dx
  }
  return _EAX;
}

void OutPortL(unsigned Port, unsigned long Value)
{
  asm {
    mov dx,[Port]
    mov eax,[Value]
    out dx,eax
  }
}



unsigned short DoDetect(signed short Startoff, unsigned long* BaseA)
{
  signed short Result = AskForCard();
  if ( Result == -1 ) return 0;
  *BaseA = ValBase(DetectedCard[Result].Base[Startoff]);
  return 1;
}

unsigned short DoDetect(signed short Startoff, unsigned long* BaseA, unsigned char* IRQLine)
{
  signed short Result = AskForCard();
  if ( Result == -1 ) return 0;
  *BaseA = ValBase(DetectedCard[Result].Base[Startoff]);
  *IRQLine = DetectedCard[Result].IRQ;
  return 1;
}

unsigned short DoDetect(signed short Startoff, unsigned long* BaseA, unsigned long* BaseB)
{
  signed short Result = AskForCard();
  if ( Result == -1 ) return 0;
  *BaseA = ValBase(DetectedCard[Result].Base[Startoff]);
  *BaseB = ValBase(DetectedCard[Result].Base[Startoff + 1]);
  return 1;
}

unsigned short DoDetect(signed short Startoff, unsigned long* BaseA, unsigned long* BaseB, unsigned char* IRQLine)
{
  signed short Result = AskForCard();
  if ( Result == -1 ) return 0;
  *BaseA = ValBase(DetectedCard[Result].Base[Startoff]);
  *BaseB = ValBase(DetectedCard[Result].Base[Startoff + 1]);
  *IRQLine = DetectedCard[Result].IRQ;
  return 1;
}

unsigned long __fastcall GetTick(void)
{
    //register unsigned long Result;
    __emit__(0x0F, 0x31);
    return _EAX;
}

unsigned long GetClockHz(void)
{
    unsigned long Tick, ClockHz;
    Tick = GetTick();
    delay(100);
    ClockHz = GetTick();
    ClockHz = (ClockHz - Tick) * 10;
    return ClockHz;
}

void dispDW()
{ double foo=0.0L;
  foo  = double(NumSamples) * double(ClockHz);
  foo /= double(Naui);
  foo *= 1e-6 * double(SIZEOFXFER);
  cprintf("%lf MDWORDS/sec, %lf MBYTES/sec\r\n",foo,foo*4);
}

void dispW()
{ double foo=0.0L;
  foo  = double(NumSamples) * double(ClockHz);
  foo /= double(Naui);
  foo *= 1e-6 * double(SIZEOFXFER);
  cprintf("%lf MWORDS/sec, %lf MBYTES/sec\r\n",foo,foo*2);
}

void dispB()
{ double foo=0.0L;
  foo  = double(NumSamples) * double(ClockHz);
  foo /= double(Naui);
  foo *= 1e-6 * double(SIZEOFXFER);
  cprintf("%lf MBYTES/sec\r\n",foo);
}


void DoMEMRead(void)
{
            Den = GetTick();
            for ( I = 0; I < NumSamples; ++I )
            {
              _EAX = *(FP+2);
              _EAX = *(FP+1);
              _EAX = *FP;
            }
            datavalue=_EAX;
            Naui = GetTick();
            Naui -= Den;
            cputs("MEM RD DW: ");dispDW();
}

void DoMEMWrite(void)
{
            Den = GetTick();
            for ( I = 0; I < NumSamples; ++I )
            {
              *FP=I;
              *(FP+1)=I;
              *(FP+2)=I;
            }
            Naui = GetTick();
            Naui -= Den;
            datavalue = I;
            cputs("MEM WR DW: ");dispDW();
}

void DoIOReadDW(void)
{
            Den = GetTick();
            for ( I = 0; I < NumSamples; ++I )
            {
              asm{
                mov dx,[Base2]
                in  eax,dx
                inc dx
                in  eax,dx
                inc dx
                in  eax,dx
              }
            }
            Naui = GetTick();
            Naui -= Den;
            datavalue = I;
            cputs("IO RD DW: "); dispDW();
}

void DoIOWriteDW()
{
            Den = GetTick();
            for ( I = 0; I < NumSamples; ++I )
            {
              asm{
                mov dx,[Base2]
                out dx,eax
                inc dx
                out dx,eax
                inc dx
                out dx,eax
              }
            }
            Naui = GetTick();
            Naui -= Den;
            datavalue = I;
            cputs("IO WR DW: "); dispDW();
}

void DoIOReadW(void)
{
            Den = GetTick();
            for ( I = 0; I < NumSamples; ++I )
            {
              asm{
                mov dx,[Base2]
                in  ax,dx
                inc dx
                in  ax,dx
                inc dx
                in  ax,dx
              }
            }
            Naui = GetTick();
            Naui -= Den;
            datavalue = I;
            cputs("IO RD W : "); dispW();
}

void DoIOWriteW(void)
{
            Den = GetTick();
            for ( I = 0; I < NumSamples; ++I )
            {
              asm{
                mov dx,[Base2]
                out dx,ax
                inc dx
                out dx,ax
                inc dx
                out dx,ax
              }
            }
            Naui = GetTick();
            Naui -= Den;
            datavalue = I;
            cputs("IO WR W : "); dispW();
}
void DoIOReadB(void)
{
            Den = GetTick();
            for ( I = 0; I < NumSamples; ++I )
            {
              asm{
                mov dx,[Base2]
                in  al,dx
                inc dx
                in  al,dx
                inc dx
                in  al,dx
              }
            }
            Naui = GetTick();
            Naui -= Den;
            datavalue = I;
            cputs("IO RD B : "); dispB();
}

void DoIOWriteB(void)
{
            Den = GetTick();
            for ( I = 0; I < NumSamples; ++I )
            {
              asm{
                mov dx,[Base2]
                out dx,al
                inc dx
                out dx,al
                inc dx
                out dx,al
              }
            }
            Naui = GetTick();
            Naui -= Den;
            datavalue = I;
            cputs("IO WR B : "); dispB();
}

/**********************************************************************
***********************************************************************
***********************************************************************/
void main(void)
{
  directvideo=1;
  do{
    char ending=0,done=0,key=0;
    DetectedCards = 0;
    clrscr();
    textmode(C4350);
    textattr(0x07);

    if ( !DoDetect(0, &Base, &Base2) ) return;

    do{
      Segm = (Base >> 4);
      Off = (Base & 0xF);
      DSegm=FP_SEG(buf);
      DOff=FP_OFF(buf);
      FP = (unsigned long*)MK_FP(Segm, Off);
      I = 0L;

      while(kbhit()) getch();
      cprintf("Base Address[2]: %lx\n\rBase Address[3]=%lx\n\r",Base,Base2);
      cprintf(
        "Press (`) for automated IO benchmarking\n\r"
        "Press (1) for MEM READ\n\r"
        "Press (2) for MEM WRITE\n\r"
        "Press (3) for MEM Burst READ\n\r"
        "Press (5) for IO READ DWORD\n\r"
        "Press (6) for IO WRITE DWORD\n\r"
        "Press (7) for IO READ BYTE\n\r"
        "Press (8) for IO WRITE BYTE\n\r"
        "Press (9) for IO READ WORD\n\r"
        "Press (0) for IO WRITE WORD\n\r"
  //      "Press () for IO Burst READ (NYI)\n\r"
        "Press (x) to stop and exit program\n\r"
      );
      key = getch();
      switch(key){
        case '`':
          DoIOReadB();
          DoIOWriteB();
          DoIOReadW();
          DoIOWriteW();
          DoIOReadDW();
          DoIOWriteDW();
          done=1;
          break;
        case '1':
          clrscr();
          cprintf(
          "First up: READING \n\r"
          "This will read as fast as possible using non-bulk techniques.\n\r"
          "On the scope it will be 3 quick followed by a short pause\n\r"
          "The time from the start of one short pause to the next should be\n\r"
          "the time we care about (how long to read all bits).\n\r"
          "Press any key to continue\n\r"
          );
          cprintf("READING MEM NOW\n\r");
          do{
            DoMEMRead();
          }while(!kbhit());
          break;
        case '2':
          clrscr();
          cprintf(
          "okay now we're going to OUTPUT to the card.  It is in input mode, \n\r"
          "so it won't do anything cool on the pins (maybe we'll do that tomorrow)\n\r"
          "but you should be able to see it.  It is *not* in bulk mode.\n\r"
          "Press any key to begin\n\r"
          );
          cprintf("WRITING NOW\n\r");
          do{
            DoMEMWrite();
          }while(!kbhit());
          break;
        case '3':
/*
          clrscr();
          cprintf(
          "okay Doug, here goes.  When you hit a key the program is going to \n\r"
          "issue 3-DWORD bulk input commands.  It is not faster than non-bulk,\n\r"
          "we don't think your card is responding *with* bulk. \n\r"
          "Press any key to continue\n\r"
          );
          cprintf("BULK?? READING NOW\n\r");
          do{
            Den = GetTick();
            { _EAX=NumSamples;
              asm{
                push eax es ds ecx edi esi
                mov es,[DSegm]
                mov edi,[DOff]
                mov esi,[Off]
                mov ds,[Segm]
              }
    loopitgood:
              asm{
                mov ecx,SIZEOFXFER
                rep movsd

                sub esi,SIZEOFXFER*4
                sub edi,SIZEOFXFER*4
                sub EAX,1
                jnz loopitgood

                pop esi edi ecx ds es eax
              }

            }
            Naui = GetTick();
            Naui -= Den;
            datavalue=buf[0];
            dispDW();
          }while(!kbhit());
*/
          break;
        case '5':
          clrscr();
          cprintf(
          "Now we're going to READ via I/O.\n\r"
          "Press any key to exit\n\r"
          );
          cprintf("I/O READING NOW\n\r");
          do{
            DoIOReadDW();
          }while(!kbhit());
          break;
        case '6':
          clrscr();
          cprintf(
          "Now we're going to WRITE via I/O.\n\r"
          "Press any key to begin\n\r"
          );
          cprintf("I/O WRITING NOW\n\r");

          do{
            DoIOWriteDW();
          }while(!kbhit());
          break;

        case '7': // IO READ BYTE
          clrscr();
          cprintf(
          "Now we're going to READ BYTE via I/O.\n\r"
          "Press any key to end\n\r"
          );
          cprintf("I/O READING NOW\n\r");

          do{
            DoIOReadB();
          }while(!kbhit());
          break;
        case '8': // IO WRITE BYTE
          clrscr();
          cprintf(
          "Now we're going to WRITE BYTEs via I/O.\n\r"
          "Press any key to begin\n\r"
          );
          cprintf("I/O WRITING NOW\n\r");

          do{
            DoIOWriteB();
          }while(!kbhit());
          break;
        case '9': // IO READ WORD
          clrscr();
          cprintf(
          "Now we're going to READ WORD via I/O.\n\r"
          "Press any key to begin\n\r"
          );
          cprintf("I/O READING NOW\n\r");

          do{
            DoIOReadW();
          }while(!kbhit());

          break;
        case '0': // IO WRITE WORD
          clrscr();
          cprintf(
          "Now we're going to WRITE WORD via I/O.\n\r"
          "Press any key to begin\n\r"
          );
          cprintf("I/O WRITING NOW\n\r");

          do{
            DoIOWriteW();
          }while(!kbhit());

          break;

  /*      case '7':cprintf("NOT YET IMPLEMENTED\n\r");
                 cprintf("Base2=%lx, Base3=%lx",Base,Base2);
                 break;
  */
        case 'X':ending=1;
        case 'x':done=1;
      }//end switch(key);
    }while (!done);
  }while (0);
}